Subject: [PATCH 2/5] ARM: PXA: Zipit Z2: Add USB host and device support

From: [email-masked] (Daniel Mack)
Date: Tue, 30 Oct 2012 21:05:10 +0100

On 30.10.2012 21:01, Vasily Khoruzhick wrote:
> On Mon, Oct 29, 2012 at 2:14 PM, Daniel Mack <[email-masked]> wrote:
>> On 29.10.2012 12:12, Vasily Khoruzhick wrote:
>>> On Mon, Oct 29, 2012 at 2:00 PM, Daniel Mack <[email-masked]> wrote:
>>>
>>>>> Well, there's an issue - Z2 does not preserve memory contents in deep sleep
>>>>> (but it does in sleep), so userspace can't be fixed here unfortunatelly.
>>>>> There's no another possibility to turn Z2 off, and plain sleep is too
>>>>> power hungry.
>>>>> So the only way to keep Z2 in low-power mode is fake power off, which just puts
>>>>> Z2 in deep sleep.
>>>>
>>>> Why can't the userspace trigger a deep sleep then instead of powering
>>>> off? Which details do I lack?
>>>
>>> How? echo mem >/sys/power/state puts system into non-deep sleep. Anyway, kernel
>>> is not ready for fake power off instead of suspend (we can't resume
>>> from deep sleep,
>>> memory content is not preserved), so there can be some data loss.
>>> Adding some sysfs file to control sleep type does not look like a good
>>> idea to me.
>>>
>>> Btw, how other DT-capable boards handle power off?
>>
>> No idea. I never actually used that kind of power state.
> 
> Hi Daniel,
> 
> One more question: what should I use instead of pxa2xx_mfp_config in
> DT board to configure pin modes?

Haojian was working on the PXA pinctrl drivers, but I don't know how far
that is yet.

If that's not yet there, have a look at the pinctrl-single driver. It's
admittedly not as nice to use as the constants in the board file as DT
lacks defines for numerical constants, but's at least a workaround.

On a more general note, it's arguable whether this kind of setup should
be done in the bootloader after all.

Daniel